Bug 60533 - Brackets (..),{..},[..] inverted )..(,}..{,]..[ when switch to RTL text direction with all fonts (Affect : calc, impress, draw).
Summary: Brackets (..),{..},[..] inverted )..(,}..{,]..[ when switch to RTL text dir...
Status: VERIFIED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: graphics stack (show other bugs)
Version:
(earliest affected)
Inherited From OOo
Hardware: Other All
: high major
Assignee: Not Assigned
URL:
Whiteboard: target:6.1.0
Keywords:
: 92641 117294 (view as bug list)
Depends on:
Blocks: RTL-CTL 33302
  Show dependency treegraph
 
Reported: 2013-02-09 09:38 UTC by navin patidar
Modified: 2018-09-30 15:24 UTC (History)
13 users (show)

See Also:
Crash report or crash signature:


Attachments
screenshot (69.30 KB, image/png)
2013-02-09 09:38 UTC, navin patidar
Details
Example of the bug (1.31 MB, video/ogg)
2014-05-23 03:43 UTC, Shimi Chen
Details
Screenshot of a new test. (26.59 KB, image/png)
2016-06-16 07:42 UTC, Marina Latini (CIB)
Details
Impress rendering the same slide with different BIDI in presentation mode (with two screens) (158.25 KB, image/png)
2018-04-28 12:16 UTC, Avihay
Details

Note You need to log in before you can comment on or make changes to this bug.
Description navin patidar 2013-02-09 09:38:44 UTC
Created attachment 74477 [details]
screenshot

Steps to reproduce bug. 

1. Start any of following Libo app calc, impress, draw.
2. Enable CTL.
3. Type text enclosed within brackets e.g. (Libreoffice)
4. Switch to RTL Writing mode.


Result :
Brackets are inverted.  )Libreoffice(
Comment 1 Lior Kaplan 2013-02-09 10:18:25 UTC
Which version on LibreOffice and which OS ?
Comment 2 Lior Kaplan 2013-02-09 19:22:32 UTC
Reproduced with 4.0.0, but this only happens when the text in the brackets is English (or probably any LTR language). If the text is a RTL language is looks OK in both directionalities, probably due to its strong BIDI directionality.
Comment 3 Lior Kaplan 2013-02-09 19:26:35 UTC
Notice this one doesn't affect writer.
Comment 4 Not Assigned 2013-02-25 08:23:59 UTC
navin patidar committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=6708ad7f1baa8d4cef1718bdef1d26fb5d8510f3

fix fdo#60533, Set TEXT_LAYOUT_BIDI_STRONG flag.



The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 5 Lior Kaplan 2013-03-07 14:24:10 UTC
Verified fix on master build.
Comment 6 Commit Notification 2013-03-14 16:22:47 UTC
navin patidar committed a patch related to this issue.
It has been pushed to "libreoffice-4-0":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=fc7a1b54cf8edbc52fb48e89043d3b9f9a742a4b&h=libreoffice-4-0

fix fdo#60533, Set TEXT_LAYOUT_BIDI_STRONG flag.


It will be available in LibreOffice 4.0.3.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 7 abdulmajeed 2013-06-09 11:23:47 UTC
this patch have cause two new bugs fdo65414   and  fdo65562
Comment 8 Petr Mladek 2013-06-11 07:30:48 UTC
Lior asked me to revert this patch in libreoffice-4-0-4 branch to avoid the regressions in 4.0.4 bugfix release. IMHO, it makes sense because the regressions looks more serious that the original bug.

Please, try to come up with a better fix before the 4.0.5 bugfix release.
Comment 9 Commit Notification 2013-06-11 07:47:22 UTC
Petr Mladek committed a patch related to this issue.
It has been pushed to "libreoffice-4-0":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=a49614e0b38424fa8c23b62c142141b49ba50af3&h=libreoffice-4-0

Revert "fix fdo#60533, Set TEXT_LAYOUT_BIDI_STRONG flag."


It will be available in LibreOffice 4.0.5.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 10 Commit Notification 2013-06-11 08:04:00 UTC
Petr Mladek committed a patch related to this issue.
It has been pushed to "libreoffice-4-0-4":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=41900bab0d07332aa720c92f787d90c4d8fff571&h=libreoffice-4-0-4

Revert "fix fdo#60533, Set TEXT_LAYOUT_BIDI_STRONG flag."


It will be available already in LibreOffice 4.0.4.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 11 Commit Notification 2013-06-11 08:12:23 UTC
Petr Mladek committed a patch related to this issue.
It has been pushed to "libreoffice-4-1":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=361c25f0ea5c0bae486fb7083d09138ffc8fcedc&h=libreoffice-4-1

Revert "fix fdo#60533, Set TEXT_LAYOUT_BIDI_STRONG flag."


It will be available in LibreOffice 4.1.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 12 Commit Notification 2013-06-11 08:12:47 UTC
Petr Mladek committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=0de49e5d365a0ca3e667bcdd68630296b5e840d6

Revert "fix fdo#60533, Set TEXT_LAYOUT_BIDI_STRONG flag."



The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 13 Petr Mladek 2013-06-11 08:49:27 UTC
Other developers suggested to revert it also on the other branches to have consistent state and avoid the regressions in further release.
Comment 14 Petr Mladek 2013-06-11 08:53:22 UTC
I have closed the regressions caused by the original fix: bug 65414 and bug 65562. Please, make sure that they does not happen when you provide a better fix for this bug.

Anyway, thanks for working on the RTL bugs. It is much appreciated.
Comment 15 Michael Meeks 2014-03-25 12:16:58 UTC
update to new mab.
Comment 16 tommy27 2014-05-05 21:16:14 UTC
please retest against 4.2.x
if bug persists please move it to mab4.2 list since 4.1.x is EOL
Comment 17 Joel Madero 2014-05-23 02:32:42 UTC
Ubuntu 14.04 x64
LibreOffice 4.2.4.2 release


Cannot reproduce with 4.2.4.2 release

Closing as WFM - if you can reproduce this on 4.2.4.2 release please set to NEW again and move to mab4.2. Thanks!
Comment 18 Shimi Chen 2014-05-23 03:43:30 UTC
Created attachment 99604 [details]
Example of the bug

Can reproduce on Build ID: 4.2.4.2 Arch Linux build-1.
Attached screen recording.
Comment 19 Joel Madero 2014-05-23 03:52:56 UTC
Do you think you could bibisect this? Is it a regression?
Comment 20 tommy27 2014-05-23 05:39:05 UTC
moved to mab4.2 list
Comment 21 Björn Michaelsen 2014-07-12 20:13:04 UTC
MABs should be priority highest.
Comment 22 tommy27 2014-12-07 18:19:14 UTC
please retest with current LibO 4.3.4.1 or 4.4.0.0 beta

if issue persists, please move this to mab4.3 list since 4.2.x is END OF LIFE
Comment 23 Robinson Tryon (qubit) 2014-12-07 18:56:30 UTC
CONFIRMED with LO 4.4.0.0.beta2 and 4.3.5.1 on Ubuntu 14.04

(In reply to navin patidar from comment #0)
> Steps to reproduce bug.
> 1. Start any of following Libo app calc, impress, draw.

Started Impress.

> 2. Enable CTL.
Tools -> Options -> Language Settings -> Languages -> Complex text layout (check box, click "OK")

> 3. Type text enclosed within brackets e.g. (Libreoffice)

> 4. Switch to RTL Writing mode.

View -> Toolbars -> Text Formatting
(this will enable the buttons for LTR and RTL)

> Result :
> Brackets are inverted.  )Libreoffice(

Brackets are inverted, but only while editing.

Because this was a mab4.2 I'm adding it to mab4.3, however given that it only affects parens while editing, is it really a MAB?
Comment 24 tommy27 2014-12-08 09:08:45 UTC
@Robinson Tryon (qubit)

once we finish the mab4.2 to mab4.3 migration I think it would be nice to review all the opened 4.3 MABs to see if they really meet the criteria to be listed as most annoying bugs.
Comment 25 Lior Kaplan 2015-08-30 08:41:06 UTC
Still happens with 4.4.5 (Official packages for deb 64bit).
Comment 26 Marina Latini (CIB) 2016-06-16 07:42:58 UTC
Created attachment 125683 [details]
Screenshot of a new test.

Brackets are inverted only in some cases.
Comment 27 Xisco Faulí 2017-07-13 10:13:44 UTC
Setting Assignee back to default. Please assign it back to yourself if you're
still working on this issue
Comment 28 Omer Zak 2017-11-03 02:01:03 UTC
Still happens in:

Version: 5.4.2.2.0+
Build ID: 1:5.4.2-3~bpo9+1
CPU threads: 8; OS: Linux 4.9; UI render: default; VCL: gtk2; 
Locale: en-US (en_US.utf8); Calc: group

OS: Debian 64bit Stretch (Debian 9.2, with some backported packages)


I tested with Impress, Default (English) UI.
Comment 29 Commit Notification 2018-03-01 12:41:00 UTC
Mark Hung committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=e85aa0cc8b306c2f5ca6240b99e1704f772dbebb

tdf#60533 invoke ubidi_setPara with correct paraLevel parameter.

It will be available in 6.1.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 30 Mark Hung 2018-03-03 05:33:39 UTC
*** Bug 92641 has been marked as a duplicate of this bug. ***
Comment 31 Ahmad Harthi 2018-03-04 08:44:28 UTC
(In reply to Commit Notification from comment #29)

Verified fix on Master.

Thank you Mark.
Comment 32 Xisco Faulí 2018-04-27 17:38:41 UTC
*** Bug 117294 has been marked as a duplicate of this bug. ***
Comment 33 Avihay 2018-04-28 12:16:45 UTC
Created attachment 141738 [details]
Impress rendering the same slide with different BIDI in presentation mode (with two screens)

Version: 6.1.0.0.alpha1+ (x64)
Build ID: a6a38c6de9c18fd1269fc8cfc0e070ef429c8e2f
CPU threads: 4; OS: Windows 10.0; UI render: default; 
TinderBox: Win-x86_64@42, Branch:master, Time: 2018-04-28_01:58:12
Locale: he-IL (he_IL); Calc: CL
Comment 34 Avihay 2018-04-28 12:21:07 UTC
As requested, reproduced https://bugs.documentfoundation.org/show_bug.cgi?id=117294 with up to date dev version

This doesn't happen in edit mode

Source file:
https://webcourse.cs.technion.ac.il/236360/Spring2018/ho/WCFiles/T1_lexical_analysis.pptx
slide 8